
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

//
//
//
//
//

#include <stdlib.mqh>

//
//
//
//
//

extern string Name_Expert            = "StepMaHLA Ea";
extern bool   EcnBroker              = true;
extern bool   UseAutoMagic           = true;
extern int    ManualMagic            = 989887876;  
extern double lStopLoss              = 60;
extern double sStopLoss              = 60;
extern double lTakeProfit            = 200;
extern double sTakeProfit            = 200;
extern double lTrailingStop          = 50;
extern double sTrailingStop          = 50;
extern int    Slippage               = 4;
extern double Lots                   = 0.1;
extern double MaximumRisk            = 0;
extern double DecreaseFactor         = 3;

extern bool   UseHLAClose            = true;
extern int    clBar                  = 1;

extern int    StepMaTimeFrame        = 0;
extern int    StepMaBar              = 1;       
extern int    Length                 = 2;          // Volty Length
extern double Kv                     = 0.95;        // Sensivity Factor
extern int    StepSize               = 0;        // Constant Step Size (if need)
extern int    MA_Mode                = 1;          // Volty MA Mode : 0-SMA, 1-LWMA 
extern int    Advance                = 0;          // Offset
extern double Percentage             = 0;          // Percentage of Up/Down Moving
extern double UpDownShift            = 0;          // Number of Up/Down Moving, in points. 
extern bool   HighLow                = false;      // High/Low Mode Switch (more sensitive)
extern int    LB                     = 20;
extern int    hlaBar                 = 1;

extern string ____TimeFilter         = "Time filter settings";
extern string Trade.startFrom        = "00:00";
extern string Trade.endAt            = "20:00";

extern bool   ShowAlerts             = false;
extern color  clOpenBuy              = Blue;
extern color  clCloseBuy             = Aqua;
extern color  clOpenSell             = Red;
extern color  clCloseSell            = Violet;

//
//
//
//
//

string s_symbol;

int    digit;
int    MAGIC;
int    ColorMode = 2; 

double PointRatio;
double point;

//
//
//
//
//

int init() 
{
  s_symbol = Symbol();
  if (UseAutoMagic) MAGIC = GetMagic();
              else  MAGIC = ManualMagic;  
              
return(0);
}

//
//
//
//
//

int deinit() { Comment(""); return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{

   if (StringSubstr(s_symbol,0,2)=="_t") s_symbol = StringSubstr(s_symbol,2);
   digit  = MarketInfo(s_symbol,MODE_DIGITS);
   if (digit==2 || digit==4) PointRatio = 1;
   if (digit==3 || digit==5) PointRatio = 10;
   if (digit==6)             PointRatio = 100;
   point  = MarketInfo(s_symbol,MODE_POINT) * PointRatio;  
                  
   //
   //
   //
   //
   //
   
   
   if (Bars < 100) { Print("bars less than 100"); return(0); }
   
   //
   //
   //
   //
   //
   
   bool canEnterNewTrade=true;
   if (canEnterNewTrade)
   {
      string     st1 = normalizeTime(Trade.startFrom);
      string     et1 = normalizeTime(Trade.endAt);
      datetime   ts1  = StrToTime(TimeToStr(TimeCurrent(),TIME_DATE)+st1); datetime ts2 = ts1;
      datetime   te1  = StrToTime(TimeToStr(TimeCurrent(),TIME_DATE)+et1); datetime te2 = te1;
      if (te1<ts1) { ts1 -= 24*60*60; te2 += 24*60*60; }
      canEnterNewTrade = ((TimeCurrent()>=ts1 && TimeCurrent()<=te1) || (TimeCurrent()>=ts2 && TimeCurrent()<=te2));
   }

   //
   //
   //
   //
   //
   
   if(lStopLoss   < 10) {  Print("StopLoss less than 10");   return(0);  }
   if(lTakeProfit < 10) {  Print("TakeProfit less than 10"); return(0);  }
   if(sStopLoss   < 10) {  Print("StopLoss less than 10");   return(0);  }
   if(sTakeProfit < 10) {  Print("TakeProfit less than 10"); return(0);  }
   
   //
   //
   //
   //
   //
   
   if (!ExistPositions() && canEnterNewTrade)
   {
     double trendCurr = iCustom(s_symbol,StepMaTimeFrame,"StepMA_v7",Length,Kv,StepSize,MA_Mode,Advance,Percentage,UpDownShift,HighLow,ColorMode,5,StepMaBar  );
     double trendPrev = iCustom(s_symbol,StepMaTimeFrame,"StepMA_v7",Length,Kv,StepSize,MA_Mode,Advance,Percentage,UpDownShift,HighLow,ColorMode,5,StepMaBar+1);
     double hlaNow    = iCustom(s_symbol,0,"High-Low Activator","",LB,false,false,false,false,false,false,0,hlaBar);
     double hlaPre    = iCustom(s_symbol,0,"High-Low Activator","",LB,false,false,false,false,false,false,0,hlaBar+1);
     
     if (trendCurr > 0 && hlaNow > hlaPre)
     {
        OpenBuy();
        return(0);
     }
     
     if (trendCurr < 0 && hlaNow < hlaPre)
     {
        OpenSell();
        return(0);
     }

   }
   TrailingPositionsBuy(lTrailingStop);
   TrailingPositionsSell(sTrailingStop);
   if(UseHLAClose) CheckForClose();
   
return (0);
}

//
//
//
//
//

bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) {
				return(true);
			}
		} 
	} 
	return(false);
}

//
//
//
//
//

void TrailingPositionsBuy(int trailingStop) { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_BUY) { 
               if (Bid-OrderOpenPrice()     > trailingStop * point) { 
                  if (OrderStopLoss() < Bid - trailingStop * point) 
                      ModifyStopLoss(   Bid - trailingStop * point); 
                 } 
              } 
           } 
        } 
    } 
}

//
//
//
//
//
 
void TrailingPositionsSell(int trailingStop) { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_SELL) { 
               if (OrderOpenPrice() -   Ask > trailingStop * point) { 
                  if (OrderStopLoss() > Ask + trailingStop * point || OrderStopLoss() == 0)  
                      ModifyStopLoss(   Ask + trailingStop * point); 
                 } 
              } 
           } 
        } 
    } 
}

//
//
//
//
//
 
void ModifyStopLoss(double ldStopLoss) 
{ 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE); 
   
   if (fm == false)
   {
	  int    ErrorCode = GetLastError();
	  string ErrDesc   = ErrorDescription(ErrorCode);

	  string ErrAlert  = StringConcatenate("Trailing Stop Modification - Error ",ErrorCode,": ",ErrDesc);
	  if (ShowAlerts   == true) Alert(ErrAlert);

	  string ErrLog    = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",ldStopLoss);
	  Print(ErrLog);
	}
 
} 

//
//
//
//
//

void OpenBuy() 
{ 
    
   double lbStop = GetStopLossBuy(); 
   double lbTake = GetTakeProfitBuy();
   
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker) 
         OrderSend(s_symbol,OP_BUY,LotsOptimized(),Ask,Slippage*point,lbStop,lbTake,Name_Expert,MAGIC,0,clOpenBuy); 
   else
   {
         int buyTicket    = OrderSend(s_symbol,OP_BUY,LotsOptimized(),Ask,Slippage*point,0,0,Name_Expert,MAGIC,0,clOpenBuy);		    		    
         if (buyTicket   >= 0)
         bool buyOrderMod = OrderModify(buyTicket,OrderOpenPrice(),lbStop,lbTake,0,CLR_NONE);
         
         if (buyOrderMod  == false)
         {
         
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Buy Order - Error ",ErrorCode,": ",ErrDesc);
           if (ShowAlerts   == true) Alert(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",Ask," Bid: ",Bid," Ticket: ",buyTicket," Stop: ",lbStop," Profit: ",lbTake);
           Print(ErrLog);
         }
    }		       

}

//
//
//
//
//

void OpenSell() 
{ 

   double lsStop = GetStopLossSell(); 
   double lsTake = GetTakeProfitSell();
   
   //
   //
   //
   //
   //
   
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker)
         OrderSend(s_symbol,OP_SELL,LotsOptimized(),Bid,Slippage*point,lsStop,lsTake,Name_Expert,MAGIC,0,clOpenSell); 
   else
   {
         int sellTicket    = OrderSend(s_symbol,OP_SELL,LotsOptimized(),Bid,Slippage*point,0,0,Name_Expert,MAGIC,0,clOpenSell);		    		    
         if (sellTicket    >= 0)
         bool sellOrderMod = OrderModify(sellTicket,OrderOpenPrice(),lsStop,lsTake,0,CLR_NONE);
         
         if (sellOrderMod  == false)
         {
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Sell Order - Error ",ErrorCode,": ",ErrDesc);
           if (ShowAlerts   == true) Alert(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",Ask," Bid: ",Bid," Ticket: ",sellTicket," Stop: ",lsStop," Profit: ",lsTake);
           Print(ErrLog);
          }
    }		       
} 

//
//
//
//
//

void CheckForClose()  
{
   RefreshRates();
   double clNow  = iCustom(s_symbol,0,"High-Low Activator","",LB,false,false,false,false,false,false,0,clBar);
   double clPre  = iCustom(s_symbol,0,"High-Low Activator","",LB,false,false,false,false,false,false,0,clBar+1);
   double clpPre = iCustom(s_symbol,0,"High-Low Activator","",LB,false,false,false,false,false,false,0,clBar+2);
     
   
   //
   //
   //
   //
   //
   
   for (int i = 0;i < OrdersTotal(); i++)
   {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false)  break;
      if (OrderMagicNumber()!= MAGIC)                         continue;
      if (OrderSymbol()     != s_symbol)                      continue;
      
      //
      //
      //
      //
      //
      
      if (OrderType() == OP_BUY)
      {
        if (clNow < clPre && clPre >= clpPre) 
        {
           bool buyClose = OrderClose(OrderTicket(),OrderLots(),Bid,Slippage*point,clCloseBuy);
           if (buyClose == false)
           {
             int ErrorCode   = GetLastError();
             string ErrDesc  = ErrorDescription(ErrorCode);

             string ErrAlert = StringConcatenate("Close Buy Order - Error ",ErrorCode,": ",ErrDesc);
             if (ShowAlerts  == true) Alert(ErrAlert);

             string ErrLog   = StringConcatenate("Bid: ",Bid," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
             Print(ErrLog);
           }
        }
        break;
      }
      
      //
      //
      //
      //
      //
        
      if (OrderType() == OP_SELL)
      {
        if (clNow > clPre && clPre <= clpPre) 
        {
          bool sellClose = OrderClose(OrderTicket(),OrderLots(),Ask,Slippage*point,clCloseSell); 
          if (sellClose  == false)
          {
             ErrorCode  = GetLastError();
             ErrDesc    = ErrorDescription(ErrorCode);

             ErrAlert  = StringConcatenate("Close Sell Order - Error ",ErrorCode,": ",ErrDesc);
             if (ShowAlerts == true) Alert(ErrAlert);

             ErrLog   = StringConcatenate("Ask: ",Ask," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
             Print(ErrLog);
          }
        }
        break;
      }
   }
}

//
//
//
//
//

double GetStopLossBuy()    { 	return(Bid - lStopLoss   * point); } 
double GetStopLossSell()   { 	return(Ask + sStopLoss   * point); } 
double GetTakeProfitBuy()  { 	return(Ask + lTakeProfit * point); } 
double GetTakeProfitSell() { 	return(Bid - sTakeProfit * point); } 

//
//
//
//
//

double LotsOptimized()
{
   double lot_min  = MarketInfo(s_symbol,MODE_MINLOT);
   double lot_max  = MarketInfo(s_symbol,MODE_MAXLOT);
   double lot_step = MarketInfo(s_symbol,MODE_LOTSTEP);
   double contract = MarketInfo(s_symbol,MODE_LOTSIZE);
   double lot      = Lots;
   int    orders   = HistoryTotal();     // history orders total
   int    losses   = 0;                  // number of losses orders without a break
   
   //
   //
   //
   //
   //
   
   if(lot_min < 0.0 || lot_max <= 0.0 || lot_step <= 0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   if (MaximumRisk > 0)
   {
   lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk * AccountLeverage()/contract,2);
   }
   
   if(DecreaseFactor>0)
   {
      for(int i=orders-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
      if(OrderSymbol()!= s_symbol || OrderType() > OP_SELL) continue;
      
      //
      //
      //
      //
      //
      
      if(OrderProfit() > 0) break;
      if(OrderProfit() < 0) losses++;
      }
   if(losses>1) lot=NormalizeDouble(lot - lot * losses/DecreaseFactor,2);
   }
   
   //
   //
   //
   //
   //
   
   lot=NormalizeDouble(lot/lot_step,0)*lot_step;
   if(lot<lot_min) lot=lot_min;
   if(lot>lot_max) lot=lot_max;
   
return(lot);
} 

//----------------------------------------------------------------------------------------
//       normalize time       
//----------------------------------------------------------------------------------------
//
//
//
//
//

string normalizeTime(string time)
{
   int sepAt  = StringFind(time,":",0);
   int hour   = StrToInteger(StringSubstr(time,0,sepAt));
   int minute = StrToInteger(StringSubstr(time,sepAt+1,0));
   
   //
   //
   //
   //
   //
   
   hour   = MathMax(MathMin(hour  ,24),0);
   minute = MathMax(MathMin(minute,59),0);
   string answer="";
      while(true)
      {
         if (hour==0) { answer="00";     break; }
         if (hour<10) { answer="0"+hour; break; }
                        answer=    hour; break; 
      }                        
      while(true)
      {
         if (minute==0) { answer=answer+":00";       break; }
         if (minute<10) { answer=answer+":0"+minute; break; }
                          answer=answer+":" +minute; break; 
      }
   return(" "+answer); 
}

//
//
//
//
//

int GetMagic() 
{

   if (s_symbol == "CADJPY") return(91902921);
   if (s_symbol == "CADCHF") return(91903922);
   
   if (s_symbol == "GOLD")   return(91904931);
   if (s_symbol == "SILVER") return(91922932);
   
   if (s_symbol == "NZDJPY") return(91905941);
   if (s_symbol == "NZDUSD") return(91906942);
   
   if (s_symbol == "CHFJPY") return(91907951);
   
   if (s_symbol == "EURAUD") return(91908961);
   if (s_symbol == "EURCAD") return(91909962);
   if (s_symbol == "EURUSD") return(91910963);
   if (s_symbol == "EURGBP") return(91911964);
   if (s_symbol == "EURCHF") return(91912965);
   if (s_symbol == "EURNZD") return(91913966);
   if (s_symbol == "EURJPY") return(91914967);
   
   if (s_symbol == "GBPUSD") return(91915971);
   if (s_symbol == "GBPCHF") return(91916972);
   if (s_symbol == "GBPJPY") return(91917973);
   
   if (s_symbol == "USDCHF") return(91918981);
   if (s_symbol == "USDJPY") return(91919982);
   if (s_symbol == "USDCAD") return(91920983);

   if (s_symbol == "AUDUSD") return(91921991);
   if (s_symbol == "AUDNZD") return(91923992);
   if (s_symbol == "AUDCAD") return(91924993);
   if (s_symbol == "AUDCHF") return(91925994);
   if (s_symbol == "AUDJPY") return(91926295);
   
   return(ManualMagic);
}



